import { Injectable, PLATFORM_ID, Inject } from '@angular/core';
import { CanActivate, Router } from '@angular/router';
import { AuthService } from '../services/auth.service';
import { isPlatformBrowser } from '@angular/common';

@Injectable({
  providedIn: 'root',
})
export class AuthGuard implements CanActivate {
  
  constructor(
    private authService: AuthService, 
    private router: Router,
    @Inject(PLATFORM_ID) private platformId: Object
  ) {}

  async canActivate(): Promise<boolean> {
    // 1. SSR CHECK: Wenn wir auf dem Server sind, immer erlauben!
    // Der Server soll nicht redirecten, sondern einfach das HTML rendern.
    if (!isPlatformBrowser(this.platformId)) {
      return true; 
    }

    // 2. CLIENT CHECK: Das läuft nur im Browser
    const token = await this.authService.getToken();
    if (token) {
      return true;
    } else {
      this.router.navigate(['/login-register']);
      return false;
    }
  }
}
